import { ImageDefinition } from "sanity";
import { ImageOptions } from "sanity";
import { Plugin as Plugin_2 } from "sanity";

/**
 * @public
 */
export declare interface QRCodeDefinition
  extends Omit<ImageDefinition, "type" | "options"> {
  type: "qrCode";
  options?: QRCodeOptions;
}

/**
 * @public
 */
export declare const QRCodeGenerator: Plugin_2<void | QRCodeGeneratorConfig>;

/**
 * @public
 * @deprecated use the {@link QRCodeGenerator}.
 *
 * ```ts
 * import { QRCodeGenerator } from 'sanity-qr-code-generator';
 * ```
 */
export declare const QrCodeGenerator: Plugin_2<QrCodeGeneratorConfig | void>;

/**
 * @public
 */
export declare interface QRCodeGeneratorConfig {}

/**
 * @public
 * @deprecated use the {@link QRCodeGeneratorConfig}.
 *
 * ```ts
 * import { type QRCodeGeneratorConfig } from 'sanity-qr-code-generator';
 * ```
 */
export declare type QrCodeGeneratorConfig = QRCodeGeneratorConfig;

/**
 * @public
 */
export declare interface QRCodeOptions extends ImageOptions {
  dependOn?: string | string[];
  /**
   * @default 500
   */
  size?: number;
  /**
   * @default "#FFFFFF"
   */
  bgColor?: string;
  /**
   * @default "#000000"
   */
  fgColor?: string;
  /**
   * @default "L"
   */
  level?: "L" | "M" | "H" | "Q";
}

export {};

declare module "sanity" {
  interface IntrinsicDefinitions {
    qrCode: QRCodeDefinition;
  }
}
